"""
Copyright 2008-2014 by Aerospike, Inc. All rights reserved.
THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE. THE COPYRIGHT NOTICE
ABOVE DOES NOT EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION.
"""


# -*- coding: utf-8 -*-
from constants import *


class HandleSeedDownWithVersion(object):

    def __call__(self, fn):

        def decorator(self):

            result = fn(self)
            unsupported_version_found = False
            if result != UNABLE_TO_CONNECT and result != UNSUPPORTED_VERSION:
                self.set_status_on()
                return result
            elif result == UNSUPPORTED_VERSION:
                unsupported_version_found = True

            seed = self.get_seed()
            for node in self._nodes:
                if node == seed:
                    continue
                ip, port = node.split(":")
                result = fn(self, ip, port)
                if result != UNABLE_TO_CONNECT and result != UNSUPPORTED_VERSION:
                    self.set_seed(node)
                    self.set_status_on()
                    return result
                elif result == UNSUPPORTED_VERSION:
                    unsupported_version_found = True

            if unsupported_version_found is False:
                self.set_status_off()
                return UNABLE_TO_CONNECT
            else:
                return UNSUPPORTED_VERSION

        return decorator
