import os
import sys
import commands

amc = "/opt/amc/server"
site_packages = "%s/site-packages" % amc
greenlet_so = "%s/greenlet.so" % site_packages
greenlet_setup = "%s/setups/greenlet" % amc
sys.path.insert(1,'%s/' % site_packages)

def can_import_greenlet():

    try:
        import greenlet
    except:
        return 0
    return 1

def generate_greenlet():

    greenlets = [] #["greenlet-mac.so", "greenlet-deb.so", "greenlet-deb6.so", "greenlet-rpm.so"]
    for greenlet in greenlets:
        os.system("rm -f %s" % greenlet_so)       
        os.system("mv %s/%s %s" % (greenlet_setup, greenlet, greenlet_so))
        if can_import_greenlet():
            return 1
    try:
        sys.stderr.write("building greenlet...\n")
        sys.stderr.write("You may check greenlet compilation output in /tmp/greenlet.log and delete it if all is OK\n")
        os.chdir("%s/greenlet-0.4.1" % greenlet_setup)
        exit_status, output = commands.getstatusoutput("python setup.py install --home=%s --install-lib=%s --install-headers=%s" % (site_packages, site_packages, site_packages))
        f = open('/tmp/greenlet.log', 'w')
        f.write(output)
        f.close()

        if exit_status != 0:
            sys.stderr.write("AMC dependency not met. Please install gcc and python-dev (for Debian/Ubuntu) or python-devel (for CentOS/RedHatLinux) before installing AMC.\n")
            return 0
        if can_import_greenlet():
            return 1
        else:
            return 0
    except:
        return 0

